## nodejs 20.13.1%2Bdfsg

=== debian/changelog ===
nodejs (20.13.1+dfsg-2) unstable; urgency=medium

  * Flaky sequential/test-worker-heapsnapshot-options.
    Closes: #1071382

 -- Jérémy Lal <kapouer@melix.org>  Sat, 18 May 2024 14:26:22 +0200

nodejs (20.13.1+dfsg-1) unstable; urgency=medium

  * New upstream version 20.13.1+dfsg

 -- Jérémy Lal <kapouer@melix.org>  Wed, 15 May 2024 13:52:04 +0200

nodejs (20.13.0+dfsg-1) experimental; urgency=medium

  * New upstream version 20.13.0+dfsg
  * test-fs-utimes* fail because of libuv1 bug
  * mark some more tests as flaky
  * watch: ada 2.7.8

 -- Jérémy Lal <kapouer@melix.org>  Wed, 08 May 2024 19:48:54 +0200

nodejs (20.12.2+dfsg-1) experimental; urgency=medium

  * New upstream version 20.12.2+dfsg
  * copyright:
    + exclude tools/gyp
    + simplifications
    + fix license ~holders
  * patch: add link to upstream bug
  * Suggests node-corepack
  * Include permission headers
  * Override lintian warning about brotli test
  * Deps:
    + pkg-config becomes pkgconf
    + python3-packaging
    + gyp >= 0.16
  * Breaks/Replace libnode108, libnode109
  * Drop python3-distutils from deps/test deps. Closes: #1065909
  * Let some riscv64, mips64el tests fail.
  * openssl 3.2 compatibility patch
  * mark setuid tests as failing, because this nodejs version
    does not support setuid with shared libuv. See: CVE-2024-22017
  * multilib patch: process.config not in shadow realm

 -- Jérémy Lal <kapouer@melix.org>  Tue, 23 Apr 2024 11:53:20 +0200

nodejs (20.10.0+dfsg-1) experimental; urgency=medium

  * New upstream version 20.10.0+dfsg
  * Drop kfreebsd-*, mips(el) architectures
  * new architecture: loong64, thanks to Shi Pujin  
  * patch:
    + remove mips-related, refresh
    + let loong64 have some failing tests
    + more doc for localhost-no-addrconfig
    + disable zlib embedding in v8
  * fix boostrapping of nodejs package:
    + update README.source
    + nodoc: disable bash completion output
    + patch: disable shared builtins when flag
      node-builtin-modules-path is used
  * copyright:
    + deps/v8/third_party/glibc/ with some LGPL-2.1+ code
    + exclude tools/github_reporter/index.js
    + disappeared file patterns
    + deps/v8/third_party/ittapi/include/fortran/

 -- Jérémy Lal <kapouer@melix.org>  Sat, 16 Dec 2023 13:56:50 +0100
