=== tools/release/requirements.txt ===
PyGithub==2.3.0
pytest==8.2.0
