=== debian/changelog ===
nodejs (20.15.0+dfsg-1ubuntu3) oracular; urgency=medium

  * Also skip /dev/z90crypt on strace openat test, this
    read call is added by openssl 3.2.2

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 28 Jun 2024 14:25:45 +0200

nodejs (20.15.0+dfsg-1ubuntu2) oracular; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Still use Ubuntu openssl patch and approach, the Debian one
      makes testsuite fail.
    - Drop the python3-distutils dependency
    - fix strace openat autopkgtest
    - Add tzdata-icu and strace to test

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 27 Jun 2024 07:58:32 +0200

nodejs (20.15.0+dfsg-1) unstable; urgency=medium

  * New upstream version 20.15.0+dfsg
  * Mark test-worker-prof as flaky on mips64el/loong64
  * VCS is on master-20.x branch now

 -- Jérémy Lal <kapouer@melix.org>  Tue, 25 Jun 2024 12:57:00 +0200

nodejs (20.14.0+dfsg-3ubuntu1) oracular; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Still use Ubuntu openssl patch and approach, the Debian one
      makes testsuite fail.
    - Drop the python3-distutils dependency
    - fix strace openat autopkgtest
    - Add tzdata-icu and strace to test

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 20 Jun 2024 10:42:25 +0200

nodejs (20.14.0+dfsg-3) unstable; urgency=medium

  * test-cpu-prof-dir-absolute is flaky
  * Fix: skip failing test in the right suite

 -- Jérémy Lal <kapouer@melix.org>  Wed, 19 Jun 2024 12:03:27 +0200

nodejs (20.14.0+dfsg-2ubuntu1) oracular; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Still use Ubuntu openssl patch and approach, the Debian one
      makes testsuite fail.
    - Drop the python3-distutils dependency
    - fix strace openat autopkgtest
    - Add tzdata-icu and strace to test

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 12 Jun 2024 12:17:32 +0200

nodejs (20.14.0+dfsg-2) unstable; urgency=medium

  * Patch: fix tests for openssl 3.2.2. Closes: #1073013

 -- Jérémy Lal <kapouer@melix.org>  Wed, 12 Jun 2024 11:41:24 +0200

nodejs (20.14.0+dfsg-1ubuntu1) oracular; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Still use Ubuntu openssl patch and approach, the Debian one
      makes testsuite fail.
    - Drop the python3-distutils dependency
    - fix strace openat autopkgtest
    - Add tzdata-icu and strace to test

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 06 Jun 2024 00:23:43 +0200

nodejs (20.14.0+dfsg-1) unstable; urgency=medium

  * New upstream version 20.14.0+dfsg

  [ Gianfranco Costamagna ]
  * Drop double newline in changelog

  [ Zixing Liu ]
  * Use proper method to specify Node.js path when running tests
  * test_ci.patch: revert Makefile changes to use upstream selection logic

 -- Jérémy Lal <kapouer@melix.org>  Mon, 03 Jun 2024 13:36:41 +0200

nodejs (20.13.1+dfsg-2ubuntu6) oracular; urgency=medium

  * d/p/ubuntu-openssl-fix-strace-openat-test.patch: add back the hunk that
    accidentally got dropped.

 -- Zixing Liu <zixing.liu@canonical.com>  Tue, 28 May 2024 19:06:19 -0600

nodejs (20.13.1+dfsg-2ubuntu5) oracular; urgency=medium

  * Skip zoneinfo file, it fails on Big Endian architectures.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 28 May 2024 10:35:14 +0200

nodejs (20.13.1+dfsg-2ubuntu4) oracular; urgency=medium

  * Make sure test strace openat uses the correct OPENSSL_CONF variable.
  * Add tzdata-icu package to make sure the openssl-strace-openat test
    pulls the required files

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 27 May 2024 10:21:01 +0200

nodejs (20.13.1+dfsg-2ubuntu3) oracular; urgency=medium

  * d/p/series: Disable OpenSSL 3.2 patches on Ubuntu.
  * d/p/test-lowerseclevel.patch: Remove unneeded test workarounds
    from the patch.
  * d/p/disable-failing-tests.patch: Delete unneeded patch.
  * d/p/ubuntu-openssl-fix-strace-openat-test.patch: fix test Ubuntu also needs
    to access system icu libraries and access OpenSSL configuration in
    a different location.
  * d/p/build/test_ci.patch: refresh the patch after disabling
    OpenSSL 3.2 patch.

 -- Zixing Liu <zixing.liu@canonical.com>  Thu, 23 May 2024 14:58:21 -0600

nodejs (20.13.1+dfsg-2ubuntu2) oracular; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Still use Ubuntu openssl patch and approach, the Debian one
      makes testsuite fail.
    - Drop the python3-distutils dependency
    - ignore one additional tls issue, probably a openssl 3.2
      non-retrocompatible patch
    - Add 2 new flaky tests, regressed in release
    - Add 2 more flaky tests
  * New Changes:
    - d/patches: Refresh patches
  * Dropped changes:
    - Fix offset by one in one new test due to additional openssl conf
      file passed as parameter
    - 95534ad82f4e33f53fd50efe633d43f8da70cba6.patch,
      d1ccca9d2bd913194a70beb762876f46e46060a0.patch,
      6557c1c9b1206a85bb7d8e7450e8c3a4cff7c84b.patch
      cherry-pick fixes for Python3.12

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 22 May 2024 11:29:41 +0200

nodejs (20.13.1+dfsg-1ubuntu1) oracular; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Still use Ubuntu openssl patch and approach, the Debian one
      makes testsuite fail.
    - Drop the python3-distutils dependency
    - ignore one additional tls issue, probably a openssl 3.2
      non-retrocompatible patch
    - Add 2 new flaky tests, regressed in release
  * New Changes:
    - d/patches: Refresh patches
  * Dropped changes:
    - Fix offset by one in one new test due to additional openssl conf
      file passed as parameter
    - 95534ad82f4e33f53fd50efe633d43f8da70cba6.patch,
      d1ccca9d2bd913194a70beb762876f46e46060a0.patch,
      6557c1c9b1206a85bb7d8e7450e8c3a4cff7c84b.patch
      cherry-pick fixes for Python3.12

 -- Zixing Liu <zixing.liu@canonical.com>  Thu, 16 May 2024 09:04:25 -0600


