=== debian/rules ===
--- 
+++ 
@@ -115,7 +115,6 @@
 #  relax regression tests when targeted experimental suite
 export HOME = $(CURDIR)/tmp
 export FLAKY_TESTS = dontcare
-export TEST_CI_ARGS = --arch=$(destCpu) --timeout=3000
 export CI_JS_SUITES = message parallel sequential
 export NODE_TEST_DIR = $(CURDIR)/tmp
 export NODE_TEST_NO_INTERNET = 1
@@ -124,6 +123,15 @@
 # keep in mind ./debian/rules check is also invoked by adt-run, see debian/tests/
 exp-relax-check := $(if $(shell dpkg-parsechangelog | grep -x 'Distribution: \(experimental\|UNRELEASED\)'),-i)
 DEB_MAKE_CHECK_TARGET = $(exp-relax-check) test-ci-js
+TEST_CI_ARGS = --arch=$(destCpu) --timeout=3000
+
+# override Node.js path when running under adt-run (no build directory present)
+ifeq (,$(wildcard $(CURDIR)/out))
+TEST_CI_ARGS += --shell=/usr/bin/node
+else
+TEST_CI_ARGS += --shell=out/Release/node
+endif
+export TEST_CI_ARGS
 
 # build -fPIC
 CFLAGS += -fPIC
@@ -216,10 +224,8 @@
 
 override_dh_auto_test-arch:
 ifeq ($(filter nocheck,$(DEB_BUILD_PROFILES)),)
-	-ln -s /usr/bin/node node
 	mkdir -p $(NODE_TEST_DIR)
 	$(MAKE) $(DEB_MAKE_CHECK_TARGET)
-	rm -f node
 	rm -rf $(NODE_TEST_DIR)
 endif
 
@@ -230,5 +236,3 @@
 	dh_auto_install
 
 override_dh_install-arch:
-	sed 's/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/g' debian/libnode.install.in > debian/libnode$(ABI).install
-	sed -e 's/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/g' -e 's/@ABI@/$(ABI)/g' debian/libnode-dev.links.in > debian/libnode-dev.links
