## nodejs 20.15.1+dfsg

=== debian/changelog ===
nodejs (20.15.1+dfsg-1ubuntu1) oracular; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Use Ubuntu openssl patch and approach, the Debian one
      makes testsuite fail.
    - Drop the python3-distutils dependency
    - fix strace openat autopkgtest
    - Add tzdata-icu and strace to test

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 10 Jul 2024 08:06:47 +0200
