=== debian/control ===
--- 
+++ 
@@ -44,8 +44,8 @@
  node-highlight.js <!nodoc>,
 Standards-Version: 4.6.2
 Homepage: https://nodejs.org/
-Vcs-Browser: https://salsa.debian.org/js-team/nodejs/tree/master-18.x
-Vcs-Git: https://salsa.debian.org/js-team/nodejs.git -b master-18.x
+Vcs-Browser: https://salsa.debian.org/js-team/nodejs/tree/master-20.x
+Vcs-Git: https://salsa.debian.org/js-team/nodejs.git -b master-20.x
 Rules-Requires-Root: no
 
 Package: libnode-dev
