## nodejs 20.16.0+dfsg

=== debian/changelog ===
nodejs (20.16.0+dfsg-1ubuntu1) oracular; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Use Ubuntu openssl patch and approach, the Debian one
      makes testsuite fail.
    - Drop the python3-distutils dependency
    - fix strace openat autopkgtest
    - Add tzdata-icu and strace to test

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 19 Aug 2024 10:01:38 +0200

nodejs (20.16.0+dfsg-1) unstable; urgency=medium

  * New upstream version 20.16.0+dfsg
  * patches:
    + improve openssl 3.2.2 tests fixes
    + upstream fix for failing permissions tests in /tmp
      Closes: #1076542.

 -- Jérémy Lal <kapouer@melix.org>  Sun, 18 Aug 2024 14:48:08 +0200
