=== debian/rules ===
--- 
+++ 
@@ -123,7 +123,7 @@
 # keep in mind ./debian/rules check is also invoked by adt-run, see debian/tests/
 exp-relax-check := $(if $(shell dpkg-parsechangelog | grep -x 'Distribution: \(experimental\|UNRELEASED\)'),-i)
 DEB_MAKE_CHECK_TARGET = $(exp-relax-check) test-ci-js
-TEST_CI_ARGS = --arch=$(destCpu) --timeout=3000
+TEST_CI_ARGS = --arch=$(destCpu) --timeout=3000 --node-args="--openssl-shared-config"
 
 # override Node.js path when running under adt-run (no build directory present)
 ifeq (,$(wildcard $(CURDIR)/out))
