=== debian/tests/control ===
Test-Command: ./debian/rules override_dh_auto_test-arch
Depends: @, ca-certificates, python3, procps, curl, build-essential, tzdata-icu, strace
