=== debian/watch ===
--- 
+++ 
@@ -11,6 +11,6 @@
  https://registry.npmjs.org/@types/node https://registry.npmjs.org/@types/node/-/node-(20[\d\.]+)@ARCHIVE_EXT@ ignore
 
 opts="component=ada,filenamemangle=s%(?:.*?)?v?@ANY_VERSION@(@ARCHIVE_EXT@)%ada-$1$2%" \
- https://github.com/ada-url/ada/tags?after=v2.7.9 \
+ https://github.com/ada-url/ada/tags?after=v2.8.0 \
  (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@ ignore
